# TO DO pDataSlide more testing
#       phenoDataSlide as well
#       pDataCy3/pDataCy5 and phenoDataCy3/phenoDataCy5 as well
#       se.exprs getExprsSetDiff as well
#       concatenateExprSetArrays as well
#
# TO DO concatenateExprSetArrays
#       so far only the same list of varLabels is allowed
#
#
# possibly cf. AffyBatch for the extension of exprSet  
#
# Long Run 
# slide name / slide slot useful
# so far the slide slot is not set/used !
# would require implementation in subsetting etc.

# /**
#
# \name{initExprSetArray}
#
# \title{dummy to initialize the class exprSetArray and its methods and generics}
#
# \alias{initExprSetArray}
#
# \keyword{}
#
# \description{
#
#}
#
# \value{}
#
#
# \arguments{
#  \item{where}{where}
# }
# 
# \details{}
#
# \seealso{\code{\link{exprSetArray-class}}}
#
# \examples{
#  indCy3=1:3
#  indCy5=4:6
#  channels <- matrix( c(indCy3,indCy5), nrow=length(indCy3), byrow=FALSE )
#  colnames(channels) <- c("Cy3","Cy5")
#  eSA <- new("exprSetArray", exprs=matrix(1:60, ncol=6, nrow=10), phenoData=
#          new("phenoData", pData=data.frame(matrix(0,nrow=6,ncol=1)),
#              varLabels=list(rep("varLabel1",1))), channels=channels)
#  stopifnot( identical(pDataSlide(eSA),pData(eSA)[1:3,,drop=FALSE]) )
#  eSACy3 <- getExprSetCy3(eSA)
#  eSACy5 <- getExprSetCy5(eSA)
#  eSADiff <- getExprSetDiff(eSA)
#  eSADiff2 <- getExprSetCy3MinusCy5(eSA)
#  stopifnot( identical( eSADiff, eSADiff2 ) )
#  stopifnot( identical( exprs(eSADiff), exprs(eSACy3)-exprs(eSACy5)) )
#  eSAPart <- eSA[,c(1,3,1,4,6,4)]
#  eSAInvalid <- eSA[,c(1,3,1,5,6,4),type="invalidExprSetArray"]
#  eSAPart2 <- slideSubset(eSA,j=c(1,3,1))
#  stopifnot( identical( exprs(eSAPart), exprs(eSAPart2) ) )
#  ind <- c(1,1,3,2,3,3)
#  stopifnot( identical( exprs(eSADiff[,ind]), exprs(eSACy3[,ind])-exprs(eSACy5[,ind])) )
#  stopifnot( dim(exprs(eSADiff[,ind]))[2] == length(ind) )
#  eSAPart <- eSA[,1:3] # not recommended
#  stopifnot(identical(eSACy3, getExprSetCy3(eSAPart)))
#  stopifnot(identical(eSACy3[,c(1,1,1)], getExprSetCy3(eSAPart[,c(1,1,1)])))
#  stopifnot(identical(eSACy3[,c(TRUE,TRUE,TRUE)], getExprSetCy3(eSAPart[,c(TRUE,TRUE,TRUE)])))
#  stopifnot(identical(eSACy3[,c(FALSE,FALSE,FALSE)], getExprSetCy3(eSAPart[,c(FALSE,FALSE,FALSE)])))
#  stopifnot(identical(eSACy3[,c(FALSE,TRUE,FALSE)], getExprSetCy3(eSAPart[,c(FALSE,TRUE,FALSE)])))
#  print(eSA)
#  print(phenoDataSlide(eSA))
#  print(pDataSlide(eSA))
#  print(phenoDataCy3(eSA))
#  print(pDataCy3(eSA))
#  print(phenoDataCy5(eSA))
#  print(pDataCy5(eSA))
#  eSAeSA <- concatenateExprSetArrays(objectOne=eSA,objectTwo=eSA)
#  eSAeSAPart2 <- concatenateExprSetArrays(objectOne=eSA,objectTwo=eSAPart2)
#  stopifnot( class(exprSet(eSA)) == "exprSet" )
# }
#
# \author{Andreas Buness <a.buness@dkfz.de>}
# */

initExprSetArray <- function(where){

  
  setClass(Class="exprSetArray", representation(
             indCy3="vector", indCy5="vector", slides="vector"),
           prototype=list( indCy3=numeric(),
             indCy5=numeric(), slides=vector(mode="character")), 
             contains="exprSet", where=where)
  
  # the method inititialize seem to have to set the slots ... 
  setMethod("initialize", signature=signature(.Object="exprSetArray"), definition=function(.Object, channels=array(0, dim=c(0,2), dimnames=list(NULL,c("Cy3","Cy5"))), exprs=matrix(nr=0,nc=0), phenoData=new("phenoData") , se.exprs = matrix(nr=0,nc=0), notes="" ){

    # channels
    stopifnot( ! any(is.null(channels)) )
    stopifnot( ! any(is.na(channels)) )
    stopifnot( ! any(is.nan(channels)) )
    stopifnot( length(dim(channels)) == 2 ) # two dimensions
    stopifnot( "Cy3" %in% colnames(channels) )
    stopifnot( "Cy5" %in% colnames(channels) )
    indCy3 <- channels[,"Cy3"]
    indCy5 <- channels[,"Cy5"]
    if( ! any(is.null(rownames(channels))) ){
      slides <- rownames(channels)
    }else{
      slides <- 1:dim(channels)[1]
    }

    # setting of slots
    .Object@exprs <- exprs
    .Object@se.exprs <- se.exprs
    .Object@notes <- notes
    .Object@phenoData <- phenoData
    .Object@indCy3 <- indCy3
    .Object@indCy5 <- indCy5
    #.Object@slides <- slides

    # do not allow NA
    stopifnot( ! any(is.na(indCy3)) )
    stopifnot( ! any(is.na(indCy5)) )

    # actually NULL is impossible since is.vector(NULL) is FALSE, cf.
    # the representation definition which is checked at initialization
    if(! is.null(getIndCy3(.Object)) & ! is.null(getIndCy5(.Object)) &
       ! is.null(exprs(.Object)) ){
      
      stopifnot(length(getIndCy3(.Object)) == length(getIndCy5(.Object)) )

      stopifnot(length(getIndCy3(.Object)) + length(getIndCy5(.Object)) ==
                ncol(exprs(.Object)) )

      if( !(length(getIndCy3(.Object)) == 0 & length(getIndCy5(.Object)) == 0 )){
        stopifnot( any(!duplicated(getIndCy3(.Object))) )
        stopifnot( any(!duplicated(getIndCy5(.Object))) )
        
        stopifnot( setequal((1:ncol(exprs(.Object))),union(getIndCy3(.Object),
                                                           getIndCy5(.Object))))
      }
      if(! is.null(exprs(.Object)) &
         ! is.null(pData(.Object))
         ){
        stopifnot( ncol(exprs(.Object)) ==  nrow(pData(.Object)) )
      }
    }
    return(.Object)
  }, where=where)

  ###


  
  if( !isGeneric("concatenateExprSetArrays") ){
    setGeneric("concatenateExprSetArrays", function(objectOne,objectTwo) standardGeneric("concatenateExprSetArrays"), where=where )
  }
  setMethod("concatenateExprSetArrays",signature=signature(objectOne="exprSetArray", objectTwo="exprSetArray"), definition=function(objectOne,objectTwo){

    if( length(is.na(objectOne)) > 0 ){
      if( all(is.na(objectOne)) ){
        stop(" objectOne  is NA in concatenateExprSetArrays ")
      }
    }
    if( length(is.na(objectTwo)) > 0 ){
      if( all(is.na(objectTwo)) ){
        stop(" objectTwo  is NA in concatenateExprSetArrays ")
      }
    }
    if( is.null(objectOne) | is.null(objectTwo) ){
      stop(" objectOne or objectTwo is NULL in concatenateExprSetArrays ")
    }

    vLOne <- varLabels(phenoData(objectOne))
    vLTwo <- varLabels(phenoData(objectTwo))

    if( is.null(vLOne) | is.null(vLTwo) ){
      stop(" varLabels is NULL in concatenateExprSetArrays ")
    }
    if( length(is.na(vLOne)) > 0 ){
      if( all(is.na(vLOne)) ){
        stop(" varLabels vLOne is NA in concatenateExprSetArrays ")
      }
    }
    if( length(is.na(vLTwo)) > 0 ){
      if( all(is.na(vLTwo)) ){
        stop(" varLabels vLTwo is NA in concatenateExprSetArrays ")
      }
    }
    # extension possible: varLabels must not match in general
    if( any( unlist(vLOne) != unlist(vLTwo) ) ){
      stop(" varLabels must match in concatenateExprSetArrays ")
    }
    
    pDOne <- pData(phenoData(objectOne))
    pDTwo <- pData(phenoData(objectTwo))

    if( is.null(pDOne) | is.null(pDTwo) ){
      stop(" pData is NULL in concatenateExprSetArrays ")
    }
    if( length(is.na(pDOne)) > 0 ){
      if( all(is.na(pDOne)) ){
        stop(" pData pDOne is NA in concatenateExprSetArrays ")
      }
    }
    if( length(is.na(pDTwo)) > 0 ){
      if( all(is.na(pDTwo)) ){
        stop(" pData pDTwo is NA in concatenateExprSetArrays ")
      }
    }
    
    varLabelsList <- vLOne
    pDataDataFrame <- rbind(pDOne,pDTwo)

    phenoDataObject <- new("phenoData", pData=pDataDataFrame, varLabels=varLabelsList)
    
        
    if( dim(exprs(objectOne))[1] != dim(exprs(objectTwo))[1] ){
      stop(" different number of exprs rows in concatenateExprSetArrays ")
    }
    
    exprsMatrix <- cbind(exprs(objectOne),exprs(objectTwo))

    if( dim(se.exprs(objectOne))[1] != dim(se.exprs(objectTwo))[1] ){
      stop(" different number of se.exprs rows in concatenateExprSetArrays ")
    }
    
    se.exprsMatrix <- cbind(se.exprs(objectOne),se.exprs(objectTwo))

    if( length(getIndCy3(objectOne)) != length(getIndCy5(objectOne)) ){
      stop(" object one invalid exprSetArray in concatenateExprSetArrays ")
    }
    if( length(getIndCy3(objectTwo)) != length(getIndCy5(objectTwo)) ){
      stop(" object two invalid exprSetArray in concatenateExprSetArrays ")
    }

    offset <- length(getIndCy3(objectOne)) + length(getIndCy5(objectOne))
    channels<-as.matrix(cbind(c(getIndCy3(objectOne),
                                (getIndCy3(objectTwo)+offset)),
                              c(getIndCy5(objectOne),
                                (getIndCy5(objectTwo)+offset)) ))
    colnames(channels) <- c("Cy3","Cy5")
    
    notes <- paste(notes(objectOne)," concatenated with ", notes(objectTwo))

    concatenatedObject <- new("exprSetArray", exprs=exprsMatrix,
                        se.exprs=se.exprsMatrix, phenoData = phenoDataObject,
                        channels=channels, notes=notes)

    return(concatenatedObject)
    
  }, where=where)

  

  ###
  
    setMethod("show", signature=signature(object="exprSetArray"), definition=function(object) {
    dm <-dim(exprs(object))
    ngenes <- dm[1]
    nsamples <- dm[2]
    nslides <- length(getIndCy3(object))
    stopifnot(length(getIndCy3(object)) == length(getIndCy5(object)))
    cat(paste("exprSetArray with \n\t", ngenes, " genes\n\t", sep=""))
    cat(paste(nslides, " slides, i.e. ", nsamples," channels \n",sep=""))
    cat("phenoDataSlide:\n")
    show(phenoDataSlide(object))
    cat("phenoDataCy3:\n")
    show(phenoDataCy3(object))
    cat("phenoDataCy5:\n")
    show(phenoDataCy5(object))
  }, where=where)

  ###

  if( !isGeneric("exprSet") ){
    setGeneric("exprSet", function(object) standardGeneric("exprSet"), where=where )
  }
   setMethod("exprSet",signature=signature(object="exprSetArray"), definition=function(object){

     return(new("exprSet", exprs=exprs(object), se.exprs=se.exprs(object),
                notes=notes(object), phenoData=phenoData(object))
            )

   }, where=where)
  

  ###

  
  if( !isGeneric("getIndCy3") ){
    setGeneric("getIndCy3", function(object) standardGeneric("getIndCy3"), where=where )
  }
   setMethod("getIndCy3",signature=signature(object="exprSetArray"), definition=function(object){
     return(object@indCy3)
   }, where=where)
  if( !isGeneric("getExprSetCy3") ){
    setGeneric("getExprSetCy3", function(object) standardGeneric("getExprSetCy3"), where=where )
  }
  setMethod("getExprSetCy3",signature=signature(object="exprSetArray"), definition=function(object){
     exprsCy3 <- exprs(object)[,getIndCy3(object),drop=FALSE]
     phenoDataCy3 <- phenoData(object)[getIndCy3(object),,drop=FALSE]
     if( is.null(dim(se.exprs(object))) | length(se.exprs(object)) == 0 ){
       se.exprsCy3 <- se.exprs(object)
     }else{
       se.exprsCy3 <- se.exprs(object)[,getIndCy3(object),drop=FALSE]
     }
     notes <- notes(object)
     return(new("exprSet", exprs=exprsCy3, phenoData=phenoDataCy3, se.exprs=se.exprsCy3, notes=notes))
   }, where=where)
  
  ###
  
  if( !isGeneric("getIndCy5") ){
    setGeneric("getIndCy5", function(object) standardGeneric("getIndCy5"), where=where )
  }
   setMethod("getIndCy5",signature=signature(object="exprSetArray"), definition=function(object){
     return(object@indCy5)
   }, where=where)
  if( !isGeneric("getExprSetCy5") ){
    setGeneric("getExprSetCy5", function(object) standardGeneric("getExprSetCy5"), where=where )
  }
  setMethod("getExprSetCy5",signature=signature(object="exprSetArray"), definition=function(object){
     exprsCy5 <- exprs(object)[,getIndCy5(object),drop=FALSE]
     phenoDataCy5 <- phenoData(object)[getIndCy5(object),,drop=FALSE]
     if( is.null(dim(se.exprs(object))) | length(se.exprs(object)) == 0 ){
       se.exprsCy5 <- se.exprs(object)
     }else{
       se.exprsCy5 <- se.exprs(object)[,getIndCy5(object),drop=FALSE]
     }
     notes <- notes(object)
     return(new("exprSet", exprs=exprsCy5, phenoData=phenoDataCy5, se.exprs=se.exprsCy5, notes=notes))
   }, where=where)

  ###
  
  if( !isGeneric("getExprSetDiff") ){
    setGeneric("getExprSetDiff", function(object) standardGeneric("getExprSetDiff"), where=where )
  }
  setMethod("getExprSetDiff",signature=signature(object="exprSetArray"), definition=function(object){

    exprsCy3 <- exprs(object)[,getIndCy3(object),drop=FALSE]
    phenoDataCy3 <- phenoData(object)[getIndCy3(object),,drop=FALSE]
    pDataCy3 <- pData(phenoDataCy3)
    varLabelsCy3 <- varLabels(phenoDataCy3)
                              
    exprsCy5 <- exprs(object)[,getIndCy5(object),drop=FALSE]
    phenoDataCy5 <- phenoData(object)[getIndCy5(object),,drop=FALSE]
    pDataCy5 <- pData(phenoDataCy5)
    varLabelsCy5 <- varLabels(phenoDataCy5)

    if( is.null(dim(se.exprs(object))) | length(se.exprs(object)) == 0 ){
      se.exprsDiff <- se.exprs(object)
    }else{
      se.exprsCy3 <- se.exprs(object)[,getIndCy3(object),drop=FALSE]
      se.exprsCy5 <- se.exprs(object)[,getIndCy5(object),drop=FALSE]
      se.exprsDiff <- se.exprsCy3 + se.exprsCy5
    }
    
    exprsDiff <- exprsCy3 - exprsCy5
    pDataDiff <- cbind(pDataCy3, pDataCy5)
    stopifnot( identical(varLabelsCy3,varLabelsCy5) )
    varLabelsDiff <- c(varLabelsCy3,varLabelsCy5)

    notes <- notes(object)
    
    return(new("exprSet", exprs=exprsDiff, se.exprs=se.exprsDiff, phenoData=
               new("phenoData",pData=pDataDiff, varLabels=varLabelsDiff)
               , notes=notes))
  }, where=where)


  if( !isGeneric("getExprSetCy3MinusCy5") ){
    setGeneric("getExprSetCy3MinusCy5", function(object) standardGeneric("getExprSetCy3MinusCy5"), where=where )
  }
  
  setMethod("getExprSetCy3MinusCy5",signature=signature(object="exprSetArray"), definition=function(object){
    
    return(getExprSetDiff(object))
    
  }, where=where)
  
    
  if( !isGeneric("phenoDataCy3") ){
    setGeneric("phenoDataCy3", function(object) standardGeneric("phenoDataCy3"), where=where )
  }
  setMethod("phenoDataCy3",signature=signature(object="exprSetArray"), definition=function(object){
    
    phenoDataCy3 <- phenoData(object)[getIndCy3(object),,drop=FALSE]
    pDataCy3 <- pData(phenoDataCy3)
    varLabelsCy3 <- varLabels(phenoDataCy3)

    return(new("phenoData",pData=pDataCy3, varLabels=varLabelsCy3))
    
  }, where=where)

  if( !isGeneric("pDataCy3") ){
    setGeneric("pDataCy3", function(object) standardGeneric("pDataCy3"), where=where )
  }
  setMethod("pDataCy3",signature=signature(object="exprSetArray"), definition=function(object){
    
    return(pData(phenoDataCy3(object)))
    
  }, where=where)
  

    
  if( !isGeneric("phenoDataCy5") ){
    setGeneric("phenoDataCy5", function(object) standardGeneric("phenoDataCy5"), where=where )
  }
  setMethod("phenoDataCy5",signature=signature(object="exprSetArray"), definition=function(object){
    
    phenoDataCy5 <- phenoData(object)[getIndCy5(object),,drop=FALSE]
    pDataCy5 <- pData(phenoDataCy5)
    varLabelsCy5 <- varLabels(phenoDataCy5)

    return(new("phenoData",pData=pDataCy5, varLabels=varLabelsCy5))
    
  }, where=where)

  if( !isGeneric("pDataCy5") ){
    setGeneric("pDataCy5", function(object) standardGeneric("pDataCy5"), where=where )
  }
  setMethod("pDataCy5",signature=signature(object="exprSetArray"), definition=function(object){
    
    return(pData(phenoDataCy5(object)))
    
  }, where=where)
  
  
  
  if( !isGeneric("phenoDataSlide") ){
    setGeneric("phenoDataSlide", function(object) standardGeneric("phenoDataSlide"), where=where )
  }
  setMethod("phenoDataSlide",signature=signature(object="exprSetArray"), definition=function(object){

    indCy3 <-getIndCy3(object)
    indCy5 <- getIndCy5(object)
    stopifnot( length(indCy3) == length(indCy5) )
    if( length(indCy3) == 0 ){
      return( new("phenoData") )
    }
    channels <- matrix(c(indCy3,indCy5),byrow=FALSE, nrow=length(indCy3), ncol=2)
    fullPhenoData <- phenoData(object)
    fullPData <- pData(object)
    if( length(fullPData) == 0 ){
      return( new("phenoData")  )
    }
    # dim(comp) covariates x slides
    comp <- apply(channels, 1, function(x){return(fullPData[x[1],] == fullPData[x[2],])})
    # if more than one pData covariate
    if( dim(fullPData)[2] > 1 ){ 
      if( length( dim(comp) ) == 2 ){
        # dim(comp) covariates x slides
        stopifnot( dim(comp)[2] == length(indCy3)) 
        stopifnot( dim(comp)[1] == dim(fullPData)[2] )
        colBoolean <- apply(comp,1, function(x) return(all(x, na.rm=TRUE)) )
        stopifnot( length(colBoolean) == dim(fullPData)[2] )
      }else{
        print(comp)
        stop("unexpected case, expected two-dimensional object")
      }
    }else if( dim(fullPData)[2] == 1 ){
      # length must match number of slides
      stopifnot( length(comp) == length(indCy3) )
      colBoolean <- all(comp, na.rm=TRUE)
    }else{
      stopifnot( length(comp) == 0 )
      colBoolean <- logical(0)
    }
    return(fullPhenoData[indCy3,colBoolean]) # implicit drop=FALSE in [] for phenoData
    
  }, where=where)

  if( !isGeneric("pDataSlide") ){
    setGeneric("pDataSlide", function(object) standardGeneric("pDataSlide"), where=where )
  }
  setMethod("pDataSlide",signature=signature(object="exprSetArray"), definition=function(object){

    return(pData(phenoDataSlide(object)))
    
  }, where=where)
  
  
  if( !isGeneric("slideSubset") ){
    setGeneric("slideSubset", function(object,i,j) standardGeneric("slideSubset"), where=where )
  }
  setMethod("slideSubset", signature=signature(object="exprSetArray"), definition=function(object,i,j){
    
    if( missing(j) ){
      j3 <-getIndCy3(object)
      j5 <-getIndCy5(object)
    }else{
      if( is.logical(j) ){
        stopifnot( length(j) == length(getIndCy3(object)) )
        stopifnot( length(j) == length(getIndCy5(object)) )
      }
      j3 <- getIndCy3(object)[j]
      j5 <- getIndCy5(object)[j]
      if( any(is.na(j3)) | any(is.na(j5)) ){
        stop(" slideSubset j is invalid, e.g. out of range ")
      }
    }
    channelJ <- c(j3,j5)
    if( missing(i) ){
      result <- object[,channelJ,drop=FALSE]
    }else{
      result <- object[i,channelJ,drop=FALSE]
    }
    return(result)
  }, where=where)
  
  # [ taken from exprSet.R
  # take care of indCy3 and indCy5 which relates to j
  # but the operation may not preserve the slide matching in general,
  # hence parameter type is introduced to check consistency
  setMethod("[", "exprSetArray", function(x, i, j, type="validExprSetArray", ..., drop=FALSE) {

    if( !any(type %in% c( "validExprSetArray", "invalidExprSetArray" )) ){
      stop("invalid type in subsetting exprSetArray")
    }
    
    # new line - before manipulation
    nrOfColumnsInExprsXOld <- dim(exprs(x))[2]
    
    if( missing(j) )
      pdata <- phenoData(x)
    else
      pdata <- phenoData(x)[j,, ..., drop=FALSE]
    haveSES <- nrow(se.exprs(x)) > 0
    if(missing(j) ) {
      if( missing(i) ) {
        nexprs <- exprs(x)
        if( haveSES )
          nses <- se.exprs(x)
      }
      else {
        nexprs <- exprs(x)[i, ,drop=FALSE]
        if( haveSES )
          nses <- se.exprs(x)[i, ,drop=FALSE]
      }
    }
    else {
      if( missing(i) ) {
        nexprs <- exprs(x)[,j, drop=FALSE]
        if( haveSES )
          nses <- se.exprs(x)[,j, drop=FALSE]
      }
      else {
        nexprs <- exprs(x)[i, j, drop=FALSE]
        if( haveSES )
          nses <- se.exprs(x)[i, j, drop=FALSE]
      }
    }
    exprs(x) <- nexprs
    if( haveSES )
      se.exprs(x) <- nses
    phenoData(x) <- pdata
    
    # new part
    if( !missing(j) ){
      if( length(j) > 0 ){
        newIndexes <- 1:(length(j))
        if( is.logical(j) ){
          if( length(j) != nrOfColumnsInExprsXOld ){
            stop("logical j must match dimensions of the columns of exprs(object)")
          }
          j <- which( j == TRUE )
          newIndexes <- 1:length(j)
        }
        cy3 <- newIndexes[j %in% getIndCy3(x)]
        cy5 <- newIndexes[j %in% getIndCy5(x)]

        
        # check validity/consistency of exprSetArray
        if( type == "validExprSetArray" ){
          indexesInCy3 <-sapply( j[j %in% getIndCy3(x)] ,
                                function(y) which( y==getIndCy3(x) ))
          indexesInCy5 <-sapply( j[j %in% getIndCy5(x)] ,
                                function(y) which( y==getIndCy5(x) ))
          if( !all(indexesInCy3 == indexesInCy5) ){
            stop("invalid subset operation, i.e. does not ensure validity of exprSetArray - possibly use type==\"invalidExprSetArray\" to proceed")
          }
        }
        
        # set new channel indexes
        x@indCy3 <- cy3
        x@indCy5 <- cy5

      }
    }
    return(x)
  }, where=where)

}
