# TO DO
# two line input file which contains annotation for each channel separately
# also nicht nur immer ans Referenzdesign denken ...

# example testing code is important !
# the tests directory seems to be less appropriate for testing


# /**
#
# \name{processArrayData}
#
# \title{processArrayData}
#
# \alias{processArrayData}
#
# \keyword{}
#
# \description{
#	}
#
# \synopsis{}
#
# \usage{}
#
# \arguments{
#  \item{subtractBackground}{ logical }
#  \item{spotsRemovedBeforeNormalisation}{ vector of character strings;
#       all spots which match the strings are removed from 
#       the the whole analysis, i.e. already before normalisation}
#  \item{spotsSetToZeroWeightAndRemovedAfterNormalisation}{
#       vector of character strings;
#       all spots which match the strings become zero weight
#       (weights are only used by loess type normalisations) and
#       are removed after normalisation}
#  \item{spotIdentifier}{ character string }
#  \item{mergeSlides}{ logical; at this point only used for consistency tests
#       of a hypothetical slide merge operation with respect to \code{mergeSlidesColumn} }
#  \item{slideDescriptionFile}{ character string;
#       the first line of the file must contain all column names,
#       in particular the column \code{fileNameColum} and possibly
#       \code{slideNumberColumn}
#       must be included}
#  \item{fileNameColumn}{ character string; required; default: "fileName" }
#  \item{slideNumberColumn}{ character string; optional; if missing it is set
#        to \code{fileNameColumn}; default: missing }
#  \item{mergeSlidesColumn}{ character string; optional;
#        cf. \code{\link{mergeSlides}} }
#  \item{sampleAnnotationColumns}{ possible values:
#      a vector of character strings or \code{NA};
#      \code{sampleAnnotationColumns} define
#      all columns (hybridisation covariates)
#      which are relevant for any further analysis.
#      If \code{mergeSlides} is set to \code{TRUE}
#      the annotation should be consistent for replicas.
#      All columns in \code{slideDescriptionFile} are taken
#      if set to \code{NULL} and all except of 
#      \code{fileNameColumn} and \code{slideNumberColumn} are taken
#      if set to \code{NA}. }
#  \item{loadPath}{ character string;
#      the path is used to load the \code{slideDescriptionFile} and data files;
#      note: . refers to the current/working directory
#      }
#  \item{savePath}{ character string;
#      the path is used to save the results
#      if the path does not exist a directory is created;
#      note: . refers to the current/working directory
#      }
#  \item{normalisationMethod}{character string; default: "vsn"; cf.
#        \code{\link{normalise}} }
#  \item{imageFileType}{character string; default: "GenePix"; cf.
#        \code{\link{readImageFiles}} }
#  \item{channelsSeparately}{logical; default \code{FALSE}}
#  \item{hybridisationGroups}{list of numeric vectors; default missing}
#  \item{objectsFileName}{character string; filename for saving of list of result objects }
#  \item{plotOutput}{character string specifying
#        either "screen" or "pdf"; default: "screen"}
# }
#
# \examples{
#       LOADPATH <- file.path(.path.package("arrayMagic"), "data")
#       SAVEPATH <- LOADPATH
# 	SLIDEDESCRIPTIONFILE <- "slideDescription.txt"
#  
# 	resultList <- processArrayData(
#                             loadPath=LOADPATH, 
#  	                      savePath=SAVEPATH,
#                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
#                             sampleAnnotationColumns=NA
#                  )
#       writeToFile(exprSetArrayObject=resultList$exprSetArrayObject,
#                   arrayDataObject=resultList$arrayDataObject,
#                   fileName=file.path(SAVEPATH,"normalisedData.txt"))
#       summarizedResult <- slideMerge(
#                                           exprSetArrayObject=resultList$exprSetArrayObject,
#                                           slideMergeVariable="replicates",
#                                           sampleAnnotationColumns=
#                                              resultList$sampleAnnotationColumns
#                                          )
#
#        qPL <- qualityParameters(arrayDataObject=resultList$arrayDataObject,
#                         exprSetArrayObject=resultList$exprSetArrayObject)
#
#
#        visualiseQualityParameters(qualityParametersList=qPL$qualityParameters)
#
#        qualityDiagnostics(exprSetArrayObject=resultList$exprSetArrayObject,
#                    arrayDataObject=resultList$arrayDataObject,
#                    normObject=resultList$normObject,
#                    qualityParametersList=qPL)
#
# 	 resultListG <- processArrayData(
#                             loadPath=LOADPATH, 
#  	                      savePath=SAVEPATH,
#                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
#                             sampleAnnotationColumns=NA,
#                             plotOutput="pdf",
#                             hybridisationGroups = list((1:4),(5:9))
#                  )
#   \testonly{
# 	result2 <- processArrayData(
#                             loadPath=LOADPATH, 
#  	                      savePath=SAVEPATH,
#                             spotsRemovedBeforeNormalisation = "Blank",
#                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
#                             sampleAnnotationColumns=NA,
#                             channelsSeparately=TRUE
#                  )
# 	result3 <- processArrayData(
#                             loadPath=LOADPATH, 
#  	                      savePath=SAVEPATH,
#                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
#                             sampleAnnotationColumns=NA,
#                             channelsSeparately=TRUE,
#                             normalisationMethod="quantile"
#                  )
# 	result4 <- processArrayData(
#                             loadPath=LOADPATH, 
#  	                      savePath=SAVEPATH,
#                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
#                             sampleAnnotationColumns=NA,
#                             channelsSeparately=FALSE,
#                             normalisationMethod="quantile"
#                  )
# 	SLIDEDESCRIPTIONFILE <- "slides.txt" # slideD.tex points to complete gpr files for loess !
# 	result5 <- processArrayData(
#                             loadPath=LOADPATH, 
#  	                      savePath=SAVEPATH,
#                             spotsRemovedBeforeNormalisation = NULL,
#                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
#                             spotsSetToZeroWeightAndRemovedAfterNormalisation="Blank",
#                             sampleAnnotationColumns=NA,
#                             channelsSeparately=FALSE,
#                             normalisationMethod="loess"
#                  )
# 	result5 <- processArrayData(
#                             loadPath=LOADPATH, 
#  	                      savePath=SAVEPATH,
#                             spotsRemovedBeforeNormalisation = NULL,
#                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
#                             sampleAnnotationColumns=NA,
#                             channelsSeparately=FALSE,
#                             normalisationMethod="loessScale"
#                  )
# 	result6 <- processArrayData(
#                             loadPath=LOADPATH, 
#  	                      savePath=SAVEPATH,
#                             spotsRemovedBeforeNormalisation = NULL,
#                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
#                             sampleAnnotationColumns=NA,
#                             channelsSeparately=FALSE,
#                             hybridisationGroups = list((1:4),(5:9)),
#                             normalisationMethod="loess"
#                  )
# 	result7 <- processArrayData(
#                             loadPath=LOADPATH, 
#  	                      savePath=SAVEPATH,
#                             spotsRemovedBeforeNormalisation = NULL,
#                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
#                             sampleAnnotationColumns=NA,
#                             channelsSeparately=FALSE,
#                             hybridisationGroups = list((1:4),(5:9)),
#                             normalisationMethod="loessQuantile"
#                  )
#        qPL <- qualityParameters(arrayDataObject=result7$arrayDataObject,
#                         exprSetArrayObject=result7$exprSetArrayObject)
#
#        visualiseQualityParameters(qualityParametersList=qPL$qualityParameters,
#                                   plotOutput="pdf")
#
#        qualityDiagnostics(exprSetArrayObject=result7$exprSetArrayObject,
#                    arrayDataObject=result7$arrayDataObject,
#                    normObject=result7$normObject,
#                    qualityParametersList=qPL,
#                    plotOutput="pdf")
#
#    }     
# }
# 
#
# \seealso{\code{\link{normalise}} \code{\link{spotSlideMerge}}}
#
# \author{Andreas Buness <a.buness@dkfz.de>}
#
# */
processArrayData <- function(
                             subtractBackground=FALSE,
                             spotIdentifier = "Name",
                             spotsRemovedBeforeNormalisation = NULL,
                             spotsSetToZeroWeightAndRemovedAfterNormalisation=NULL,
                             mergeSlides = FALSE,
                             slideDescriptionFile = "slideDescription.txt",
                             fileNameColumn = "fileName",
                             slideNumberColumn,
                             mergeSlidesColumn = "replicates",
                             sampleAnnotationColumns = NULL,
                             loadPath = ".",
                             savePath = ".",
                             normalisationMethod = "vsn",
                             imageFileType = "GenePix",
                             channelsSeparately = FALSE,
                             hybridisationGroups,
                             objectsFileName = "exprSet.RData",
                             plotOutput = "screen"
                             ){

  width <- 8
  height <- 6

  if( missing( slideNumberColumn ) ){
    slideNumberColumn <- fileNameColumn
  }

  if( ! imageFileType %in% c("GenePix","ScanAlyze") ){
     stop(paste(" wrong type:",imageFileType," in processArrayData",sep=""))
  }
  
  if( ! normalisationMethod %in% c("loess", "loessScale", "loessQuantile", "quantile", "vsn" ) ){
    stop(" invalid normalisationMethod ",normalisationMethod," in processArrayData ")
  }
  
  # (occaisonally) needed package
  if( normalisationMethod == "loess" | normalisationMethod == "loessScale" |
      normalisationMethod == "loessQuantile" | normalisationMethod == "quantile" ){
    if( !require(limma) ){
      cat("require package limma \n")
      return()
    }
  }

  if( ! plotOutput %in% c("screen","pdf") ){
    warning(" unknown plotOutput in processArrayData", call.=FALSE)
    return()
  }
  
  
  # do not remove spots before normalisation
  # if method loess/loessScale/loessQuantile is used
  if( (normalisationMethod == "loess" |
       normalisationMethod == "loessScale" |
       normalisationMethod == "loessQuantile" ) ){
    if(length(spotsRemovedBeforeNormalisation) > 0 ){
      warning("spots may not be removed before normalisation if normalisationMethod==loess/loessScale/loessQuantile \n since I do not know the details of the print-tip normalisation\n and the array layout calculation \n")
    }
  }
  
  # (occaisonally) needed package
  if( normalisationMethod == "vsn" ){
    if( !require(vsn) ){
      cat("require package vsn \n")
      return()
    }
  }

  # test graphics device
  if( plotOutput == "screen" ){
    cat("\n functionality test of your graphical display")
    cat(" graphic window pops up \n")
    x11()
    cat(" and is successfully closed \n\n")
    graphics.off()
  }else if( plotOutput == "pdf" ){
    pdf(width=width,height=height,file=file.path(savePath,"testPlotEmpty.pdf"))
    graphics.off()
  }else{ 
    stop(" unexpected case; unknown plotOutput in plotDataMatrix ")
  }
  
  # check paths
  cat("\n checking existence of paths\n")
  if( any(is.na(file.info(loadPath)$isdir)) ){
    stop(" the load path does not exist \n", call.=FALSE)
  }else{
    stopifnot( file.info(loadPath)$isdir )
  }
  if( any(is.na(file.info(savePath)$isdir)) ){
    cat(" the save path does not exist\n")
    cat(" trying to create a new directory\n")
    stopifnot(dir.create(savePath))
    cat(" directory has been successfully created\n")
  }else{ if(file.info(savePath)$isdir){
  # directory exists
  }else{
    stop(paste(savePath," does exist, but is not a directory \n"),call.=FALSE)
  }
       }
  cat(" checks successfully finished\n\n")

  # description file 
  tableFile <- file.path(loadPath, slideDescriptionFile)
  if( file.exists(tableFile) ){
    cat(" using description file: ");cat(tableFile);cat("\n")
  }else{
    stop(paste(" no description file ",tableFile,"found \n"), call.=FALSE)
  }

  cat("\n\n copying description file: ");cat(tableFile);cat("\n")
  if( !file.exists(file.path(savePath, slideDescriptionFile)) ){
    cat(" to the result directory\n")
    file.copy(tableFile, file.path(savePath, slideDescriptionFile))
  }else{
    tmpString <- paste(" stopped - the description file or a file with the same name already exists in directory ",savePath,"\n",sep="")
    cat(tmpString)
  }

  # description file infos
  cat("\n count fields information for description file:\n")
  cat(tableFile);cat("\n")
  cat("\n the number of detected columns/fields (first line) \n")
  cat(" and the number of such rows (second line) \n")
  cat(" given in the description file: \n")
  cat(" (only one pair of columns/rows should appear) \n")
  cF <- count.fields(tableFile, sep="\t", quote="\"")
  if( is.null(cF)  | all(is.na(cF)) ){
    stop(" no slide description information found in file \n", call.=FALSE)
  }
  tmp <- table(cF)
  cat(format(dimnames(tmp)));cat("\n")
  cat(tmp);cat("\n")

  # read description file
  hybattr <- read.table(tableFile, sep='\t', header=TRUE, as.is=TRUE)
  cat(" column names must not contain underlines or spaces\n")
  cat("\n automatic deletion of spaces/blanks in the body of the description file, i.e.\n")
  cat(" any element/item/name should not contain underlines or spaces\n")
  for (cn in colnames(hybattr)) {
    if(is.character(hybattr[, cn])) {
      hybattr[, cn] = I(gsub(" ", "", hybattr[, cn]))
    } ## if
  } ## for
  
  cat("\n checking validity of description file\n")
  stopifnot(!is.null(hybattr[,fileNameColumn]))
  stopifnot(!is.null(hybattr[,slideNumberColumn]))
  if( mergeSlides ){
    stopifnot(!is.null(hybattr[,mergeSlidesColumn]))

  }
  if( is.null(sampleAnnotationColumns) ){
    sampleAnnotationColumns <- colnames(hybattr)
    cat( " sampleAnnotationColumns are automatically set to all, i.e.\n");
    cat( sampleAnnotationColumns ); cat("\n\n")
  }else{
    if( all(is.na(sampleAnnotationColumns)) ){
      sampleAnnotationColumns <- setdiff(colnames(hybattr[,]), c(slideNumberColumn,fileNameColumn) )
      cat( " sampleAnnotationColumns are automatically set to:\n");
      cat( sampleAnnotationColumns ); cat("\n\n")
    }
  }
  for( i in sampleAnnotationColumns){
    stopifnot(!is.null(hybattr[,i]))
  }

  imageFiles <- file.path(loadPath, hybattr[,fileNameColumn])
  tmpArrayData <- readImageFiles(fileNames=imageFiles, type=imageFileType)
  cat(" end of preprocessing \n")

  cat(" checking existence of spotIdentifier: ",spotIdentifier,"\n")
  stopifnot(!is.null(getSpotAttr(tmpArrayData)[,spotIdentifier]))
  cat(" checks successfully finished\n\n")

  # creation of a "complete" object arrayData
  arrayDataObject <- new("arrayData",intensities=getIntensities(tmpArrayData),
                         spotattr=getSpotAttr(tmpArrayData), hybattr=hybattr)

  # setting of zero weights for particular spots
  if( length(spotsSetToZeroWeightAndRemovedAfterNormalisation) > 0 ){
    arrayDataObject <- setZeroWeights(arrayDataObject=arrayDataObject, spotsWithZeroWeights=spotsSetToZeroWeightAndRemovedAfterNormalisation, spotIdentifier=spotIdentifier)
  }
    
  # spot removal before any analysis, even before normalisation
  removeSpotsResult <- removeSpots(arrayDataObject, spotsToBeRemoved=spotsRemovedBeforeNormalisation, spotIdentifier=spotIdentifier)
  arrayDataObject <- removeSpotsResult[["arrayDataObject"]]
  nrOfRemovedItems <- removeSpotsResult[["nrOfRemovedItems"]]
  cat(paste("\n before normalisation ",nrOfRemovedItems, " spots are excluded from further analysis \n\n",sep=""))

  cat(" begin of normalisation \n") 
  tmpNorm <- normalise(arrayDataObject=arrayDataObject, subtractBackground=subtractBackground, method=normalisationMethod, channelsSeparately=channelsSeparately, hybridisationGroups=hybridisationGroups)
  normData <- getNormData(tmpNorm)
  normObject <- getNormObject(tmpNorm)
  cat(" end of normalisation \n")

  # creation of a "complete" exprSetArray object of normalised data
  # complete, i.e. without merging of spots and slides 
  phenoDataObject <- new("phenoData", pData=rbind(hybattr,hybattr), varLabels=as.list(colnames(hybattr)))
  indCy3=1:ncol(normData[,"Cy3",])
  indCy5=(ncol(normData[,"Cy3",])+1):(ncol(normData[,"Cy3",])+ncol(normData[,"Cy5",]))
  channels <- matrix( c(indCy3,indCy5), nrow=length(indCy3), byrow=FALSE )
  colnames(channels) <- c("Cy3","Cy5")
  exprSetArrayObject <- new("exprSetArray", exprs=as.matrix(cbind(normData[,"Cy3",],normData[,"Cy5",])), phenoData=phenoDataObject, channels=channels)
  
  # zero weight spots are removed after normalisation
  if( length(spotsSetToZeroWeightAndRemovedAfterNormalisation) > 0 ){
    removeSpotsResultList <- removeSpots(arrayDataObject=arrayDataObject, exprSetArrayObject=exprSetArrayObject, spotsToBeRemoved=spotsSetToZeroWeightAndRemovedAfterNormalisation, spotIdentifier=spotIdentifier)
    arrayDataObject <- removeSpotsResultList[["arrayDataObject"]]
    exprSetArrayObject <- removeSpotsResultList[["exprSetArrayObject"]]
    nrOfRemovedItems <- removeSpotsResultList[["nrOfRemovedItems"]]
    cat(paste("\n after normalisation ",nrOfRemovedItems, " spots are excluded from further analysis \n\n",sep=""))
  }
  
  resultList <- list(exprSetArrayObject=exprSetArrayObject,
                     arrayDataObject=arrayDataObject,
                     sampleAnnotationColumns=sampleAnnotationColumns,
                     normObject=normObject)

  cat("\n saving objects for further processing\n\n")
  save(resultList, file=file.path(savePath,objectsFileName), compress=TRUE)
  
  return(resultList)
  
}
