%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This file was automatically generated by Rdoc on 2003-09-26 13:36:29.
% Do NOT modify this file, instead modify the source (/net/herkules/raid6/home/buness/R/Rpacks/arrayMagicCore/arrayMagic/R/processArrayData.R).
% Rdoc is copyright (C) 2001, Henrik Bengtsson, henrikb@braju.com.
% Download the Rdoc compiler at http://www.braju.com/R/
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


 \name{processArrayData}

 \title{processArrayData}

 \alias{processArrayData}

 \keyword{}

 \description{
	}

 \synopsis{}

 \usage{}

 \arguments{
  \item{subtractBackground}{ logical }
  \item{spotsRemovedBeforeNormalisation}{ vector of character strings;
       all spots which match the strings are removed from 
       the the whole analysis, i.e. already before normalisation}
  \item{spotsSetToZeroWeightAndRemovedAfterNormalisation}{
       vector of character strings;
       all spots which match the strings become zero weight
       (weights are only used by loess type normalisations) and
       are removed after normalisation}
  \item{spotIdentifier}{ character string }
  \item{mergeSlides}{ logical; at this point only used for consistency tests
       of a hypothetical slide merge operation with respect to \code{mergeSlidesColumn} }
  \item{slideDescriptionFile}{ character string;
       the first line of the file must contain all column names,
       in particular the column \code{fileNameColum} and possibly
       \code{slideNumberColumn}
       must be included}
  \item{fileNameColumn}{ character string; required; default: "fileName" }
  \item{slideNumberColumn}{ character string; optional; if missing it is set
        to \code{fileNameColumn}; default: missing }
  \item{mergeSlidesColumn}{ character string; optional;
        cf. \code{\link{mergeSlides}} }
  \item{sampleAnnotationColumns}{ possible values:
      a vector of character strings or \code{NA};
      \code{sampleAnnotationColumns} define
      all columns (hybridisation covariates)
      which are relevant for any further analysis.
      If \code{mergeSlides} is set to \code{TRUE}
      the annotation should be consistent for replicas.
      All columns in \code{slideDescriptionFile} are taken
      if set to \code{NULL} and all except of 
      \code{fileNameColumn} and \code{slideNumberColumn} are taken
      if set to \code{NA}. }
  \item{loadPath}{ character string;
      the path is used to load the \code{slideDescriptionFile} and data files;
      note: . refers to the current/working directory
      }
  \item{savePath}{ character string;
      the path is used to save the results
      if the path does not exist a directory is created;
      note: . refers to the current/working directory
      }
  \item{normalisationMethod}{character string; default: "vsn"; cf.
        \code{\link{normalise}} }
  \item{imageFileType}{character string; default: "GenePix"; cf.
        \code{\link{readImageFiles}} }
  \item{channelsSeparately}{logical; default \code{FALSE}}
  \item{hybridisationGroups}{list of numeric vectors; default missing}
  \item{objectsFileName}{character string; filename for saving of list of result objects }
  \item{plotOutput}{character string specifying
        either "screen" or "pdf"; default: "screen"}
 }

 \examples{
       LOADPATH <- file.path(.path.package("arrayMagic"), "data")
       SAVEPATH <- LOADPATH
 	SLIDEDESCRIPTIONFILE <- "slideDescription.txt"
  
 	resultList <- processArrayData(
                             loadPath=LOADPATH, 
  	                      savePath=SAVEPATH,
                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
                             sampleAnnotationColumns=NA
                  )
       writeToFile(exprSetArrayObject=resultList$exprSetArrayObject,
                   arrayDataObject=resultList$arrayDataObject,
                   fileName=file.path(SAVEPATH,"normalisedData.txt"))
       summarizedResult <- slideMerge(
                                           exprSetArrayObject=resultList$exprSetArrayObject,
                                           slideMergeVariable="replicates",
                                           sampleAnnotationColumns=
                                              resultList$sampleAnnotationColumns
                                          )

        qPL <- qualityParameters(arrayDataObject=resultList$arrayDataObject,
                         exprSetArrayObject=resultList$exprSetArrayObject)


        visualiseQualityParameters(qualityParametersList=qPL$qualityParameters)

        qualityDiagnostics(exprSetArrayObject=resultList$exprSetArrayObject,
                    arrayDataObject=resultList$arrayDataObject,
                    normObject=resultList$normObject,
                    qualityParametersList=qPL)

 	 resultListG <- processArrayData(
                             loadPath=LOADPATH, 
  	                      savePath=SAVEPATH,
                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
                             sampleAnnotationColumns=NA,
                             plotOutput="pdf",
                             hybridisationGroups = list((1:4),(5:9))
                  )
   \testonly{
 	result2 <- processArrayData(
                             loadPath=LOADPATH, 
  	                      savePath=SAVEPATH,
                             spotsRemovedBeforeNormalisation = "Blank",
                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
                             sampleAnnotationColumns=NA,
                             channelsSeparately=TRUE
                  )
 	result3 <- processArrayData(
                             loadPath=LOADPATH, 
  	                      savePath=SAVEPATH,
                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
                             sampleAnnotationColumns=NA,
                             channelsSeparately=TRUE,
                             normalisationMethod="quantile"
                  )
 	result4 <- processArrayData(
                             loadPath=LOADPATH, 
  	                      savePath=SAVEPATH,
                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
                             sampleAnnotationColumns=NA,
                             channelsSeparately=FALSE,
                             normalisationMethod="quantile"
                  )
 	SLIDEDESCRIPTIONFILE <- "slides.txt" # slideD.tex points to complete gpr files for loess !
 	result5 <- processArrayData(
                             loadPath=LOADPATH, 
  	                      savePath=SAVEPATH,
                             spotsRemovedBeforeNormalisation = NULL,
                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
                             spotsSetToZeroWeightAndRemovedAfterNormalisation="Blank",
                             sampleAnnotationColumns=NA,
                             channelsSeparately=FALSE,
                             normalisationMethod="loess"
                  )
 	result5 <- processArrayData(
                             loadPath=LOADPATH, 
  	                      savePath=SAVEPATH,
                             spotsRemovedBeforeNormalisation = NULL,
                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
                             sampleAnnotationColumns=NA,
                             channelsSeparately=FALSE,
                             normalisationMethod="loessScale"
                  )
 	result6 <- processArrayData(
                             loadPath=LOADPATH, 
  	                      savePath=SAVEPATH,
                             spotsRemovedBeforeNormalisation = NULL,
                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
                             sampleAnnotationColumns=NA,
                             channelsSeparately=FALSE,
                             hybridisationGroups = list((1:4),(5:9)),
                             normalisationMethod="loess"
                  )
 	result7 <- processArrayData(
                             loadPath=LOADPATH, 
  	                      savePath=SAVEPATH,
                             spotsRemovedBeforeNormalisation = NULL,
                             slideDescriptionFile=SLIDEDESCRIPTIONFILE,
                             sampleAnnotationColumns=NA,
                             channelsSeparately=FALSE,
                             hybridisationGroups = list((1:4),(5:9)),
                             normalisationMethod="loessQuantile"
                  )
        qPL <- qualityParameters(arrayDataObject=result7$arrayDataObject,
                         exprSetArrayObject=result7$exprSetArrayObject)

        visualiseQualityParameters(qualityParametersList=qPL$qualityParameters,
                                   plotOutput="pdf")

        qualityDiagnostics(exprSetArrayObject=result7$exprSetArrayObject,
                    arrayDataObject=result7$arrayDataObject,
                    normObject=result7$normObject,
                    qualityParametersList=qPL,
                    plotOutput="pdf")

    }     
 }
 

 \seealso{\code{\link{normalise}} \code{\link{spotSlideMerge}}}

 \author{Andreas Buness <a.buness@dkfz.de>}

 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% End of File
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
